/**
 * @module displays
 * @author Guenther Neuwirth (0626638), Manuel Mausz (0728348)
 * @brief  Implementations of CDisplay
 * @date   26.05.2009
 */

#ifndef DISPLAYS_H
#define DISPLAYS_H 1

#include <iomanip>
#include "cdisplay.h"

/**
 * @class CDisplayWDEZ
 *
 * Implementation of CDisplay
 * Prints T to stdout as decimal
 */
template <class T>
class CDisplayWDEZ
  : public CDisplay<T>
{
  public:
    CDisplayWDEZ()
      : CDisplay<T>("wdez")
    {}

    /**
     * @method display
     * @brief  prints value to display
     * @param  value  value to display
     * @return -
     * @globalvars none
     * @exception  none
     * @pre  none
     * @post none
     */
    void display(const T &value)
    {
      std::cout << std::dec << value << std::endl;
    }
};

/*============================================================================*/

/**
 * @class CDisplayWHEX
 *
 * Implementation of CDisplay
 * Prints T to stdout as decimal
 */
template <class T>
class CDisplayWHEX
  : public CDisplay<T>
{
  public:
    CDisplayWHEX()
      : CDisplay<T>("whex")
    {}

    /**
     * @method display
     * @brief  prints value to display
     * @param  value  value to display
     * @return -
     * @globalvars none
     * @exception  none
     * @pre  none
     * @post none
     */
    void display(const T &value)
    {
      std::cout << std::hex << value << std::endl;
    }
};

#endif

/* vim: set et sw=2 ts=2: */
